/*	==================================================================================	//
	File name	IEC60730.c
	Version		v1.0
	date		Aug.08.2022
	
	Brief		This is a function of IEC-60730-class B.
				The user should check [ .\IEC60730_Class_B.h ] first to choice what you need.
				
				Do not to change anything from below the program if you don't understand
				what you want.
//	==================================================================================	*/

#include	".\main.h"	////////////////////// public
#include	".\IEC60730_class_b\IEC60730.h"	// private

/* ************************************************************************************* //
	Brief		Go to reset chip when IEC60730 class B test failed.
	
	param_000	= void				= void
	return		= void				= void
// ************************************************************************************ */
void f_iec60730_go_reset( void)
{
	SYSCR2 = 0x10;	// system clock reset
}

/* ************************************************************************************* //
	Brief		The test of IEC60730 class B.
	
				BEWARE ......
				1) at STARTUP state will set << DI >>
				2) at STARTUP state will not save << IMF >>
				
	param_000	= void				= void
	return		= void				= void
// ************************************************************************************ */
void f_iec60730_class_b_startup( void)
{
	{// the standard process of IEC60730 Class B
		{
			di;	////////////////////////////// disable whole interrupt
		}
		{// init system clock
			CGCR_FCGCKSEL = 0x02;	////////// (ϵͳ Clock) fcgck = fc   = 16Mhz
			nop; nop; nop; nop; nop;////////// waiting for CGCR become stable clock
		}
	}
	{// the process of IEC60730 Class B testing
		f_iec60730_class_b_startup_pc();	// process for PC
		f_iec60730_class_b_startup_gpr();	// process for GPR
		f_iec60730_class_b_startup_sram();	// process for SRAM
		f_iec60730_class_b_startup_clock();	// process for CLOCK
		f_iec60730_class_b_startup_flash();	// process for FLASH
	}
	{// the standard process of IEC60730 Class B
		{// init system clock
			CGCR_FCGCKSEL = 0x00;	////////// (ϵͳ Clock) fcgck = fc/4 =  4Mhz(ϵͳĬ)
			nop; nop; nop; nop; nop;////////// waiting for CGCR become stable clock
		}
	}
}

/* ************************************************************************************* //
	Brief		The test of IEC60730 class B.
				
	param_000	= void				= void
	return		= void				= void
// ************************************************************************************ */
void f_iec60730_class_b_runtime( void)
{
	{// the process of IEC60730 Class B testing
		{// disable whole interrupt when running IEC60730
			r_iec60730.share.imf = EIRL_IMF;
			di;
		}
		{
			f_iec60730_class_b_runtime_sram();	// process for SRAM ( runtime )
			f_iec60730_class_b_runtime_flash();	// process for FLASH ( runtime )
		}
		{// resume the state of interrupt when leaving IEC60730
			EIRL_IMF = r_iec60730.share.imf;
		}
	}
}

/* ************************************************************************************* //
	Brief		The get result of IEC60730 class B.
				
	param_000	= void				= void
	return		= unsigned char		= 0		= all passed
									= bit 7 = 1 = failed by testing self
									= bit 6 = 1 = failed by testing self
									= bit 5 = 1 = failed by testing self
									= bit 4 = 1 = failed by testing FLASH
									= bit 3 = 1 = failed by testing CLOCK
									= bit 2 = 1 = failed by testing SRAM
									= bit 1 = 1 = failed by testing GPR
									= bit 0 = 1 = failed by testing PC
// ************************************************************************************ */
unsigned char f_iec60730_get_result( void)
{
	return r_iec60730.share.result.buf;
}

/*	==================================================================================	//	
	 Private cell code
//	==================================================================================	*/
#include	".\IEC60730_class_b\IEC60730_pc.c"
#include	".\IEC60730_class_b\IEC60730_gpr.c"
#include	".\IEC60730_class_b\IEC60730_sram.c"
#include	".\IEC60730_class_b\IEC60730_clock.c"
#include	".\IEC60730_class_b\IEC60730_flash.c"

// ************************************************************************************ //
// ************************************************************************************ //
