/*	==================================================================================	//
//	==================================================================================	*/

/* ************************************************************************************ //
	Brief		System clock
				test system clock by Fcgcr use HIRC and then Time Base Timer use dv9ck.
				to check a fixed number of loops in a single interrupt or not.
				
				BEWARE ......
				1) should run @ 4M Hz
				2) should run @ DI
				3) should run @ dv9ck been enable, mean clock source of timer is 24K Hz
				2) should run IRQ of TBT ( with dv9ck )
				
	param_000	= void				= void
	return		= unsigned char		= in "IEC60730.h", find out the keyword "d_rtn_msg_iec60730"
// *********************************************************************************** */
static	void f_iec60730_class_b_startup_clock( void)
{
	if ( r_iec60730.share.result.bit.clock == 0 )
	{
		{// init TBT
			r_iec60730.share.buf[0] = 0;	// Reset counter
			SYSCR1_DV9CK	= 1;	////////// source = flclk = 24K Hz
			TBTCR_TBTCK		= 6;	////////// set TBT speed
			EI_INTTBT		= 0;	////////// interrupt
			IL_INTTBT		= 0;	////////// irq
			TBTCR_TBTEN		= 1;	////////// TBT start
			while( IL_INTTBT == 0);
			IL_INTTBT = 0;
			while( IL_INTTBT == 0)
			{
				r_iec60730.share.buf[0]++;
				{
					nop; nop; nop; nop; nop; nop; nop; nop;
					nop; nop; nop; nop; nop; nop; nop; nop;
				}
			}
			SYSCR1_DV9CK	= 0;	// source = fsysclk
			TBTCR_TBTEN		= 0;	// TBT stop
		}
		if ( r_iec60730.share.buf[0] > ( d_ice60730_class_b_clock_middle_data + d_ice60730_class_b_clock_tolerance ) )
		{
			r_iec60730.share.result.bit.clock = 1;	// set CLOCK testing state been failed
		}
		if ( r_iec60730.share.buf[0] < ( d_ice60730_class_b_clock_middle_data - d_ice60730_class_b_clock_tolerance ) )
		{
			r_iec60730.share.result.bit.clock = 1;	// set CLOCK testing state been failed
		}
	}
}

/*	==================================================================================	//
//	==================================================================================	*/
